## libpve-access-control 8.2.0

=== Makefile ===
PACKAGE ?= libpve-access-control

DESTDIR=
PREFIX=/usr
BINDIR=$(PREFIX)/bin
SBINDIR=$(PREFIX)/sbin
MANDIR=$(PREFIX)/share/man
DOCDIR=$(PREFIX)/share/doc/$(PACKAGE)
MAN1DIR=$(MANDIR)/man1/
BASHCOMPLDIR=$(PREFIX)/share/bash-completion/completions/
ZSHCOMPLDIR=$(PREFIX)/share/zsh/vendor-completions/

export PERLDIR=$(PREFIX)/share/perl5
-include /usr/share/pve-doc-generator/pve-doc-generator.mk

all:

pveum.bash-completion: PVE/CLI/pveum.pm
	perl -I. -T -e "use PVE::CLI::pveum; PVE::CLI::pveum->generate_bash_completions();" >$@.tmp
	mv $@.tmp $@

pveum.zsh-completion: PVE/CLI/pveum.pm
	perl -I. -T -e "use PVE::CLI::pveum; PVE::CLI::pveum->generate_zsh_completions();" >$@.tmp
	mv $@.tmp $@

.PHONY: install
install: pveum.1 oathkeygen pveum.bash-completion pveum.zsh-completion
	install -d $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SBINDIR)
	install -m 0755 pveum $(DESTDIR)$(SBINDIR)
	install -m 0755 oathkeygen $(DESTDIR)$(BINDIR)
	make -C PVE install
	install -d $(DESTDIR)/$(MAN1DIR)
	install -d $(DESTDIR)/$(DOCDIR)
	install -m 0644 pveum.1 $(DESTDIR)/$(MAN1DIR)
	install -m 0644 -D pveum.bash-completion $(DESTDIR)$(BASHCOMPLDIR)/pveum
	install -m 0644 -D pveum.zsh-completion $(DESTDIR)$(ZSHCOMPLDIR)/_pveum

.PHONY: test
test:
	perl -I. ./pveum verifyapi
	perl -I. -T -e "use PVE::CLI::pveum; PVE::CLI::pveum->verify_api();"
	make -C test check

.PHONY: clean distclean
distclean: clean
clean:
	rm -f *.xml.tmp *.1 *.5 *.8 *{synopsis,opts}.adoc docinfo.xml

=== PVE/Makefile ===


.PHONY: install
install:
	make -C Auth install
	install -D -m 0644 AccessControl.pm $(DESTDIR)$(PERLDIR)/PVE/AccessControl.pm
	install -D -m 0644 RPCEnvironment.pm $(DESTDIR)$(PERLDIR)/PVE/RPCEnvironment.pm
	install -D -m 0644 TokenConfig.pm $(DESTDIR)$(PERLDIR)/PVE/TokenConfig.pm
	make -C API2 install
	make -C CLI install
	make -C Jobs install

=== test/Makefile ===

all:

.PHONY: check
check:
	perl -I.. parser_writer.pl
	perl -I.. perm-test1.pl
	perl -I.. perm-test2.pl
	perl -I.. perm-test3.pl
	perl -I.. perm-test4.pl
	perl -I.. perm-test5.pl
	perl -I.. perm-test6.pl
	perl -I.. perm-test7.pl
	perl -I.. perm-test8.pl
	perl -I.. realm_sync_test.pl
	perl -I.. api-tests.pl

=== PVE/API2/Makefile ===

API2_SOURCES= 		 	\
	AccessControl.pm 	\
	Domains.pm	 	\
	ACL.pm		 	\
	Role.pm		 	\
	Group.pm	 	\
	User.pm			\
	TFA.pm			\
	OpenId.pm

SUBDIRS = Jobs

.PHONY: install
install:
	for i in $(API2_SOURCES); do install -D -m 0644 $$i $(DESTDIR)$(PERLDIR)/PVE/API2/$$i; done
	set -e && for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done

=== PVE/Auth/Makefile ===

AUTH_SOURCES= 		 	\
	Plugin.pm 		\
	PVE.pm		 	\
	PAM.pm		 	\
	AD.pm		 	\
	LDAP.pm			\
	OpenId.pm

.PHONY: install
install:
	for i in $(AUTH_SOURCES); do install -D -m 0644 $$i $(DESTDIR)$(PERLDIR)/PVE/Auth/$$i; done

=== PVE/CLI/Makefile ===
SOURCES=pveum.pm

.PHONY: install
install: $(SOURCES)
	install -d -m 0755 $(DESTDIR)$(PERLDIR)/PVE/CLI
	for i in $(SOURCES); do install -D -m 0644 $$i $(DESTDIR)$(PERLDIR)/PVE/CLI/$$i; done


clean:

=== PVE/Jobs/Makefile ===
SOURCES=RealmSync.pm

.PHONY: install
install: ${SOURCES}
	install -d -m 0755 ${DESTDIR}${PERLDIR}/PVE/Jobs
	for i in ${SOURCES}; do install -D -m 0644 $$i ${DESTDIR}${PERLDIR}/PVE/Jobs/$$i; done

=== PVE/API2/Jobs/Makefile ===
SOURCES = \
	RealmSync.pm \

.PHONY: install
install:
	for i in $(SOURCES); do install -D -m 0644 $$i $(DESTDIR)$(PERLDIR)/PVE/API2/Jobs/$$i; done

=== debian/changelog ===
libpve-access-control (8.2.0) bookworm; urgency=medium

  * api: ACL update: fix regression where the Permissions.Modify handling
    became to strict, a user with "Permissions.Modify" on a path should be
    able to set arbitrary ACLs for that path, even without propagation.

  * pveum: user token: rename 'remove' command to 'delete' for consistency
    with other delete-commands of this tool. Keep 'remove' as alias for
    backward compatibility.

  * api: permissions: allow users to view their own permissions.

  * api: permissions: allow users to check their own tokens.

  * api: enforce a minimum length of 8 on new passwords to align with NIST's
    latest recommendation.

 -- Proxmox Support Team <support@proxmox.com>  Wed, 13 Nov 2024 17:41:50 +0100

libpve-access-control (8.1.4) bookworm; urgency=medium

  * fix #5335: sort ACL entries in user.cfg to make it easier to track changes

 -- Proxmox Support Team <support@proxmox.com>  Mon, 22 Apr 2024 13:45:22 +0200

libpve-access-control (8.1.3) bookworm; urgency=medium

  * user: password change: require confirmation-password parameter so that
    anybody gaining local or physical access to a device where a user is
    logged in on a Proxmox VE web-interface cannot give them more permanent
    access or deny the actual user accessing their account by changing the
    password. Note that such an attack scenario means that the attacker
    already has high privileges and can already control the resource
    completely through another attack.
    Such initial attacks (like stealing an unlocked device) are almost always
    are outside of the control of our projects. Still, hardening the API a bit
    by requiring a confirmation of the original password is to cheap to
    implement to not do so.

  * jobs: realm sync: fix scheduled LDAP syncs not applying all attributes,
    like comments, correctly

 -- Proxmox Support Team <support@proxmox.com>  Fri, 22 Mar 2024 14:14:36 +0100

libpve-access-control (8.1.2) bookworm; urgency=medium

  * add Sys.AccessNetwork privilege

 -- Proxmox Support Team <support@proxmox.com>  Wed, 28 Feb 2024 15:42:12 +0100

libpve-access-control (8.1.1) bookworm; urgency=medium

  * LDAP sync: fix-up assembling valid attribute set

 -- Proxmox Support Team <support@proxmox.com>  Thu, 08 Feb 2024 19:03:26 +0100

libpve-access-control (8.1.0) bookworm; urgency=medium

  * api: user: limit the legacy user-keys option to the depreacated values
    that could be set in the first limited TFA system, like e.g., 'x!yubico'
    or base32 encoded secrets.

  * oidc: enforce generic URI regex for the ACR value to align with OIDC
    specifications and with Proxmox Backup Server, which was recently changed
    to actually be less strict.

  * LDAP sync: improve validation of synced attributes, closely limit the
    mapped attributes names and their values to avoid glitches through odd
    LDIF entries.

  * api: user: limit maximum length for first & last name to 1024 characters,
    email to 254 characters (the maximum actually useable in practice) and
    comment properties to 2048 characters. This avoid that a few single users
    bloat the user.cfg to much by mistake, reducing the total amount of users
    and ACLs that can be set up. Note that only users with User.Modify and
    realm syncs (setup by admins) can change these in the first place, so this
    is mostly to avoid mishaps and just to be sure.

 -- Proxmox Support Team <support@proxmox.com>  Thu, 08 Feb 2024 17:50:59 +0100

libpve-access-control (8.0.7) bookworm; urgency=medium

  * fix #1148: allow up to three levels of pool nesting

  * pools: record parent/subpool information

 -- Proxmox Support Team <support@proxmox.com>  Mon, 20 Nov 2023 12:24:13 +0100

libpve-access-control (8.0.6) bookworm; urgency=medium

  * perms: fix wrong /pools entry in default set of ACL paths

  * acl: add missing SDN ACL paths to allowed list

 -- Proxmox Support Team <support@proxmox.com>  Fri, 17 Nov 2023 08:27:11 +0100

libpve-access-control (8.0.5) bookworm; urgency=medium

  * fix an issue where setting ldap passwords would refuse to work unless
    at least one additional property was changed as well

  * add 'check-connection' parameter to create and update endpoints for ldap
    based realms

 -- Proxmox Support Team <support@proxmox.com>  Fri, 11 Aug 2023 13:35:23 +0200

libpve-access-control (8.0.4) bookworm; urgency=medium

  * Lookup of second factors is no longer tied to the 'keys' field in the
    user.cfg. This fixes an issue where certain LDAP/AD sync job settings
    could disable user-configured 2nd factors.

  * Existing-but-disabled TFA factors can no longer circumvent realm-mandated
    TFA.

 -- Proxmox Support Team <support@proxmox.com>  Thu, 20 Jul 2023 10:59:21 +0200

libpve-access-control (8.0.3) bookworm; urgency=medium

  * pveum: list tfa: recovery keys have no descriptions

  * pveum: list tfa: sort by user ID

  * drop assert_new_tfa_config_available for Proxmox VE 8, as the new format
    is understood since pve-manager 7.0-15, and users must upgrade to Proxmox
    VE 7.4 before upgrading to Proxmox VE 8 in addition to that.

 -- Proxmox Support Team <support@proxmox.com>  Wed, 21 Jun 2023 19:45:29 +0200

libpve-access-control (8.0.2) bookworm; urgency=medium

  * api: users: sort groups to avoid "flapping" text

  * api: tfa: don't block tokens from viewing and list TFA entries, both are
    safe to do for anybody with enough permissions to view a user.

  * api: tfa: add missing links for child-routes

 -- Proxmox Support Team <support@proxmox.com>  Wed, 21 Jun 2023 18:13:54 +0200

libpve-access-control (8.0.1) bookworm; urgency=medium

  * tfa: cope with native versions in cluster version check

 -- Proxmox Support Team <support@proxmox.com>  Fri, 09 Jun 2023 16:12:01 +0200

libpve-access-control (8.0.0) bookworm; urgency=medium

  * api: roles: forbid creating new roles starting with "PVE" namespace



=== debian/control ===
Source: libpve-access-control
Section: perl
Priority: optional
Maintainer: Proxmox Support Team <support@proxmox.com>
Build-Depends: debhelper-compat (= 13),
               libanyevent-perl,
               libauthen-pam-perl,
               libnet-ldap-perl,
               libpve-cluster-perl,
               libpve-common-perl (>= 8.0.8),
               libpve-rs-perl,
               libtest-mockmodule-perl,
               liburi-perl,
               libuuid-perl,
               lintian,
               perl,
               pve-cluster (>= 6.1-4),
               pve-doc-generator (>= 5.3-3)
Standards-Version: 4.6.2
Homepage: https://www.proxmox.com

Package: libpve-access-control
Architecture: all
Depends: libauthen-pam-perl,
         libcrypt-openssl-random-perl,
         libcrypt-openssl-rsa-perl,
         libjson-perl,
         libjson-xs-perl,
         libmime-base32-perl,
         libnet-ldap-perl,
         libnet-ssleay-perl,
         libpve-cluster-perl,
         libpve-common-perl (>= 8.0.8),
         libpve-rs-perl (>= 0.8.3),
         libpve-u2f-server-perl (>= 1.0-2),
         liburi-perl,
         libuuid-perl,
         pve-cluster (>= 6.1-4),
         ${misc:Depends},
         ${perl:Depends}
Breaks: pve-manager (<< 7.0-15)
Description: Proxmox VE access control library
 This package contains the role based user management and access
 control function used by Proxmox VE.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing
